$!
$! Procedure to scan libraries and make new modules.c from the components
$! found.  Arguments:
$!	P1	Output file (e.g. modules.c)
$!	P2..P8	List of libraries to scan for modules def.
$!
$!
$   save_verify = f$verify(f$integer("0"+f$trnlnm("make_modules_verify")))
$
$    scratchFile := SYS$SCRATCH:APACHE_BUILD.TMP
$   if f$trnlnm("apache_install") .eqs. "" then define apache_install sys$disk:
$   if p1 .eqs. "" then p1 = "modules.c"
$   create apache_install:[src]modules.c	! give regular var format.
$   open/append tmpOutFile 'p1'
$
$   write tmpOutFile "/*"
$   write tmpOutFile " * modules.c --- automatically generated by Apache"
$   write tmpOutFile " * configuration script.  DO NOT HAND EDIT!!!!!"
$   write tmpOutFile " */"
$   write tmpOutFile ""
$   write tmpOutFile "#include ""httpd.h"""
$   write tmpOutFile "#include ""http_config.h""
$   write tmpOutFile ""
$
$   i = 1
$ next_moddef:
$   i = i + 1
$   thelib = P'i'
$   if thelib .nes. "" then gosub AddExternModulesDef
$   if i .lt. 8 then goto next_moddef
$
$   write tmpOutFile ""
$   write tmpOutFile "/*"
$   write tmpOutFile " *  Modules which implicitly form the"
$   write tmpOutFile " *  list of activated modules on startup,"
$   write tmpOutFile " *  i.e. these are the modules which are"
$   write tmpOutFile " *  initially linked into the Apache processing"
$   write tmpOutFile " *  [extendable under run-time via AddModule]"
$   write tmpOutFile " */"
$   write tmpOutFile "module *ap_prelinked_modules[] = {"
$
$   i = 1
$ next_prelinkdef:
$   i = i + 1
$   thelib = P'i'
$   if thelib .nes. "" then gosub AddPrelinkedModules
$   if i .lt. 8 then goto next_prelinkdef
$
$   write tmpOutFile "  NULL"
$   write tmpOutFile "};"
$   write tmpOutFile ""
$   write tmpOutFile "/*"
$   write tmpOutFile " *  Modules which initially form the"
$   write tmpOutFile " *  list of available modules on startup,"
$   write tmpOutFile " *  i.e. these are the modules which are"
$   write tmpOutFile " *  initially loaded into the Apache process"
$   write tmpOutFile " *  [extendable under run-time via LoadModule]"
$   write tmpOutFile " */"
$   write tmpOutFile "module *ap_preloaded_modules[] = {"
$   write tmpOutFile "  NULL"
$   write tmpOutFile "};"
$   write tmpOutFile ""
$
$   close tmpOutFile
$
$   save_verify = f$verify('save_verify)
$ exit
$ !__________________________________________________________________________
$
$ addExternModulesDef:
$   library/list='scratchFile'/names/width=1 'thelib'
$   open/read tmpInFile 'scratchFile'
$   loop_m:
$     read/end_of_file=eof_m tmpInFile line
$     if f$length(line) .eq. 0 then goto loop_m
$     if line .eqs. "TOP_MODULE" then goto loop_m
$     if f$extract(0,3,line) .eqs. "AP_" then goto loop_m
$     if (f$locate("_MODULE",line) + f$length("_MODULE")) .eq. f$length(line)
$     then                     
$         write tmpOutFile "extern module ''line';"
$     endif
$     goto loop_m
$   eof_m:
$   close tmpInFile
$   delete/nolog/noconfirm 'scratchFile';*
$ return
$ !__________________________________________________________________________
$ addPreLinkedModules:
$   library/list='scratchFile'/names/width=1 'thelib'
$   open/read tmpInFile 'scratchFile'
$   loop_p:
$     read/end_of_file=eof_p tmpInFile line
$     if f$extract(0,3,line) .eqs. "AP_" then goto loop_p
$     if line .eqs. "TOP_MODULE" then goto loop_p
$     if (f$locate("_MODULE",line) + f$length("_MODULE")) .eq. f$length(line)
$     then                     
$         write tmpOutFile "  &''line',"
$     endif
$     goto loop_p
$   eof_p:
$   close tmpInFile
$   delete/nolog/noconfirm 'scratchFile';*
$ return
